Skip to content
v2.274.0

CfnRcsAgent L1 construct Added in v2.274.0 ​

An AWS RCS Agent in AWS End User Messaging SMS.

The RCS agent is the top-level resource representing your brand for RCS messaging, and serves as an origination identity for sending RCS messages. A newly created agent is in CREATED status; it advances through TESTING, PARTIAL and ACTIVE only as testing and country launch registrations are submitted and approved by carriers.

Example ​

ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_smsvoice as smsvoice } from 'aws-cdk-lib';
const cfnRcsAgent = new smsvoice.CfnRcsAgent(this, 'MyCfnRcsAgent', /* all optional props */ {
  deletionProtectionEnabled: false,
  optOutListName: 'optOutListName',
  selfManagedOptOutsEnabled: false,
  tags: [{
    key: 'key',
    value: 'value',
  }],
  twoWayChannelArn: 'twoWayChannelArn',
  twoWayChannelRole: 'twoWayChannelRole',
  twoWayEnabled: false,
  twoWayMediaS3BucketName: 'twoWayMediaS3BucketName',
  twoWayMediaS3KeyPrefix: 'twoWayMediaS3KeyPrefix',
  twoWayMediaS3Role: 'twoWayMediaS3Role',
  twoWayRcsEventsEnabled: ['twoWayRcsEventsEnabled'],
});
python
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_smsvoice as smsvoice

cfn_rcs_agent = smsvoice.CfnRcsAgent(self, "MyCfnRcsAgent",
    deletion_protection_enabled=False,
    opt_out_list_name="optOutListName",
    self_managed_opt_outs_enabled=False,
    tags=[CfnTag(
        key="key",
        value="value"
    )],
    two_way_channel_arn="twoWayChannelArn",
    two_way_channel_role="twoWayChannelRole",
    two_way_enabled=False,
    two_way_media_s3_bucket_name="twoWayMediaS3BucketName",
    two_way_media_s3_key_prefix="twoWayMediaS3KeyPrefix",
    two_way_media_s3_role="twoWayMediaS3Role",
    two_way_rcs_events_enabled=["twoWayRcsEventsEnabled"]
)
java
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.smsvoice.*;

CfnRcsAgent cfnRcsAgent = CfnRcsAgent.Builder.create(this, "MyCfnRcsAgent")
        .deletionProtectionEnabled(false)
        .optOutListName("optOutListName")
        .selfManagedOptOutsEnabled(false)
        .tags(List.of(CfnTag.builder()
                .key("key")
                .value("value")
                .build()))
        .twoWayChannelArn("twoWayChannelArn")
        .twoWayChannelRole("twoWayChannelRole")
        .twoWayEnabled(false)
        .twoWayMediaS3BucketName("twoWayMediaS3BucketName")
        .twoWayMediaS3KeyPrefix("twoWayMediaS3KeyPrefix")
        .twoWayMediaS3Role("twoWayMediaS3Role")
        .twoWayRcsEventsEnabled(List.of("twoWayRcsEventsEnabled"))
        .build();
csharp
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.SMSVOICE;

var cfnRcsAgent = new CfnRcsAgent(this, "MyCfnRcsAgent", new CfnRcsAgentProps {
    DeletionProtectionEnabled = false,
    OptOutListName = "optOutListName",
    SelfManagedOptOutsEnabled = false,
    Tags = new [] { new CfnTag {
        Key = "key",
        Value = "value"
    } },
    TwoWayChannelArn = "twoWayChannelArn",
    TwoWayChannelRole = "twoWayChannelRole",
    TwoWayEnabled = false,
    TwoWayMediaS3BucketName = "twoWayMediaS3BucketName",
    TwoWayMediaS3KeyPrefix = "twoWayMediaS3KeyPrefix",
    TwoWayMediaS3Role = "twoWayMediaS3Role",
    TwoWayRcsEventsEnabled = new [] { "twoWayRcsEventsEnabled" }
});
go
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"

cfnRcsAgent := awscdk.Aws_smsvoice.NewCfnRcsAgent(this, jsii.String("MyCfnRcsAgent"), &CfnRcsAgentProps{
	DeletionProtectionEnabled: jsii.Boolean(false),
	OptOutListName: jsii.String("optOutListName"),
	SelfManagedOptOutsEnabled: jsii.Boolean(false),
	Tags: []CfnTag{
		&CfnTag{
			Key: jsii.String("key"),
			Value: jsii.String("value"),
		},
	},
	TwoWayChannelArn: jsii.String("twoWayChannelArn"),
	TwoWayChannelRole: jsii.String("twoWayChannelRole"),
	TwoWayEnabled: jsii.Boolean(false),
	TwoWayMediaS3BucketName: jsii.String("twoWayMediaS3BucketName"),
	TwoWayMediaS3KeyPrefix: jsii.String("twoWayMediaS3KeyPrefix"),
	TwoWayMediaS3Role: jsii.String("twoWayMediaS3Role"),
	TwoWayRcsEventsEnabled: []*string{
		jsii.String("twoWayRcsEventsEnabled"),
	},
})

Initializer ​

ts
new CfnRcsAgent(scope: Construct, id: string, props?: CfnRcsAgentProps)
python
CfnRcsAgent(scope: Construct, id: str, props: typing.Optional[CfnRcsAgentProps] = None)
java
new CfnRcsAgent(Construct scope, String id, CfnRcsAgentProps props)
csharp
new CfnRcsAgent(Construct scope, string id, CfnRcsAgentProps? props = null)
go
NewCfnRcsAgent(Scope Construct, Id *string, Props CfnRcsAgentProps)

Construct Props ​

deletionProtectionEnabledboolean | IResolvabledeletion_protection_enabledtyping.Union[bool, IResolvable]deletionProtectionEnabledBooleanDeletionProtectionEnabledboolDeletionProtectionEnabledinterface{}#
When set to true the RCS agent can't be deleted.

By default this is false.

optOutListNamestringopt_out_list_namestroptOutListNameStringOptOutListNamestringOptOutListName*string#
The name of the opt-out list associated with the RCS agent.
selfManagedOptOutsEnabledboolean | IResolvableself_managed_opt_outs_enabledtyping.Union[bool, IResolvable]selfManagedOptOutsEnabledBooleanSelfManagedOptOutsEnabledboolSelfManagedOptOutsEnabledinterface{}#
When set to true you're responsible for responding to HELP and STOP requests, and for tracking and honoring opt-out requests.

By default this is false.

tagsCfnTag[]tagstyping.List[CfnTag]tagsList<CfnTag>TagsCfnTag[]Tags*[]CfnTag#
An array of key-value pairs to apply to the RCS agent.
twoWayChannelArnstringtwo_way_channel_arnstrtwoWayChannelArnStringTwoWayChannelArnstringTwoWayChannelArn*string#
The Amazon Resource Name (ARN) of the two way channel where inbound messages are delivered.
twoWayChannelRolestringtwo_way_channel_rolestrtwoWayChannelRoleStringTwoWayChannelRolestringTwoWayChannelRole*string#
The Amazon Resource Name (ARN) of an IAM role for the service to assume in order to post inbound messages to the two way channel.
twoWayEnabledboolean | IResolvabletwo_way_enabledtyping.Union[bool, IResolvable]twoWayEnabledBooleanTwoWayEnabledboolTwoWayEnabledinterface{}#
When set to true two-way messaging is enabled for the RCS agent.
twoWayMediaS3BucketNamestringtwo_way_media_s3_bucket_namestrtwoWayMediaS3BucketNameStringTwoWayMediaS3BucketNamestringTwoWayMediaS3BucketName*string#
The name of the Amazon S3 bucket where inbound RCS media objects are written.
twoWayMediaS3KeyPrefixstringtwo_way_media_s3_key_prefixstrtwoWayMediaS3KeyPrefixStringTwoWayMediaS3KeyPrefixstringTwoWayMediaS3KeyPrefix*string#
The key prefix used for inbound RCS media objects in the Amazon S3 bucket.
twoWayMediaS3Rolestringtwo_way_media_s3_rolestrtwoWayMediaS3RoleStringTwoWayMediaS3RolestringTwoWayMediaS3Role*string#
The Amazon Resource Name (ARN) of the IAM role used to write inbound RCS media files to the Amazon S3 bucket.

The role must have s3:PutObject permission on the bucket and a trust policy allowing sms-voice.amazonaws.com to assume it.

twoWayRcsEventsEnabledstring[]two_way_rcs_events_enabledtyping.List[str]twoWayRcsEventsEnabledList<String>TwoWayRcsEventsEnabledstring[]TwoWayRcsEventsEnabled*[]*string#
The list of RCS event types enabled for two-way messaging.

An empty list disables all event types. The special value ALL enables all current and future event types and must be the only element if used. Requires TwoWayEnabled to be true.

Properties ​

attrCreatedTimestampstringattr_created_timestampstrattrCreatedTimestampStringAttrCreatedTimestampstringAttrCreatedTimestamp*stringrequired#
The time when the RCS agent was created.
attrPoolIdstringattr_pool_idstrattrPoolIdStringAttrPoolIdstringAttrPoolId*stringrequired#
The unique identifier of the pool associated with the RCS agent.

This is populated only while the agent is associated with a pool, which is done through the pool APIs rather than through this resource.

attrRcsAgentArnstringattr_rcs_agent_arnstrattrRcsAgentArnStringAttrRcsAgentArnstringAttrRcsAgentArn*stringrequired#
The Amazon Resource Name (ARN) of the RCS agent.
attrRcsAgentIdstringattr_rcs_agent_idstrattrRcsAgentIdStringAttrRcsAgentIdstringAttrRcsAgentId*stringrequired#
The unique identifier for the RCS agent, in the format rcs- followed by a hexadecimal string.
attrStatusstringattr_statusstrattrStatusStringAttrStatusstringAttrStatus*stringrequired#
The current status of the RCS agent.
notes

CREATED means the agent exists but no registration has been submitted. PENDING means a registration is awaiting processing. TESTING means the testing registration is approved and the agent can message registered test devices. PARTIAL means at least one country launch is active. ACTIVE means all submitted country launches are active. DELETED means the agent has been deleted.

attrTestingAgentIResolvableattr_testing_agentIResolvableattrTestingAgentIResolvableAttrTestingAgentIResolvableAttrTestingAgentIResolvablerequired#
Information about the testing agent (RCS for Business ID) associated with the RCS agent.

A testing agent is created by submitting a testing registration, and allows sending to registered test devices without carrier approval.

cdkTagManagerTagManagercdk_tag_managerTagManagercdkTagManagerTagManagerCdkTagManagerTagManagerCdkTagManagerTagManagerrequired#
Tag Manager which manages the tags for this resource.
CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#
The CloudFormation resource type name for this resource class.
Options for this resource, such as condition, update policy etc.
cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#
AWS resource type.
creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#
deletionProtectionEnabledboolean | IResolvabledeletion_protection_enabledtyping.Union[bool, IResolvable]deletionProtectionEnabledBooleanDeletionProtectionEnabledboolDeletionProtectionEnabledinterface{}#
When set to true the RCS agent can't be deleted.
logicalIdstringlogical_idstrlogicalIdStringLogicalIdstringLogicalId*stringrequired#
The logical ID for this CloudFormation stack element.

The logical ID of the element is calculated from the path of the resource node in the construct tree.

To override this value, use overrideLogicalId(newLogicalId).

nodeNodenodeNodenodeNodeNodeNodeNodeNoderequired#
The tree node.
optOutListNamestringopt_out_list_namestroptOutListNameStringOptOutListNamestringOptOutListName*string#
The name of the opt-out list associated with the RCS agent.
rcsAgentRefRcsAgentReferencercs_agent_refRcsAgentReferencercsAgentRefRcsAgentReferenceRcsAgentRefRcsAgentReferenceRcsAgentRefRcsAgentReferencerequired#
A reference to a RcsAgent resource.
refstringrefstrrefStringRefstringRef*stringrequired#
Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).

selfManagedOptOutsEnabledboolean | IResolvableself_managed_opt_outs_enabledtyping.Union[bool, IResolvable]selfManagedOptOutsEnabledBooleanSelfManagedOptOutsEnabledboolSelfManagedOptOutsEnabledinterface{}#
When set to true you're responsible for responding to HELP and STOP requests, and for tracking and honoring opt-out requests.
stackStackstackStackstackStackStackStackStackStackrequired#
The stack in which this element is defined.

CfnElements must be defined within a stack scope (directly or indirectly).

tagsCfnTag[]tagstyping.List[CfnTag]tagsList<CfnTag>TagsCfnTag[]Tags*[]CfnTag#
An array of key-value pairs to apply to the RCS agent.
twoWayChannelArnstringtwo_way_channel_arnstrtwoWayChannelArnStringTwoWayChannelArnstringTwoWayChannelArn*string#
The Amazon Resource Name (ARN) of the two way channel where inbound messages are delivered.
twoWayChannelRolestringtwo_way_channel_rolestrtwoWayChannelRoleStringTwoWayChannelRolestringTwoWayChannelRole*string#
The Amazon Resource Name (ARN) of an IAM role for the service to assume in order to post inbound messages to the two way channel.
twoWayEnabledboolean | IResolvabletwo_way_enabledtyping.Union[bool, IResolvable]twoWayEnabledBooleanTwoWayEnabledboolTwoWayEnabledinterface{}#
When set to true two-way messaging is enabled for the RCS agent.
twoWayMediaS3BucketNamestringtwo_way_media_s3_bucket_namestrtwoWayMediaS3BucketNameStringTwoWayMediaS3BucketNamestringTwoWayMediaS3BucketName*string#
The name of the Amazon S3 bucket where inbound RCS media objects are written.
twoWayMediaS3KeyPrefixstringtwo_way_media_s3_key_prefixstrtwoWayMediaS3KeyPrefixStringTwoWayMediaS3KeyPrefixstringTwoWayMediaS3KeyPrefix*string#
The key prefix used for inbound RCS media objects in the Amazon S3 bucket.
twoWayMediaS3Rolestringtwo_way_media_s3_rolestrtwoWayMediaS3RoleStringTwoWayMediaS3RolestringTwoWayMediaS3Role*string#
The Amazon Resource Name (ARN) of the IAM role used to write inbound RCS media files to the Amazon S3 bucket.
twoWayRcsEventsEnabledstring[]two_way_rcs_events_enabledtyping.List[str]twoWayRcsEventsEnabledList<String>TwoWayRcsEventsEnabledstring[]TwoWayRcsEventsEnabled*[]*string#
The list of RCS event types enabled for two-way messaging.

Methods ​

addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#
Syntactic sugar for `addOverride(path, undefined)`.
1 parameter

Parameters

  • pathpathpathpathPath — The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#
Use `addResourceDependency` instead.

This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.

addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#
Use `addResourceDependency` instead.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.

addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#
Add a value to the CloudFormation Resource Metadata.
addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#
Adds an override to the synthesized CloudFormation resource.
notes · 2 parameters

To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).

If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.

To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.

For example,

typescript
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');

would add the overrides

json
"Properties": {
  "GlobalSecondaryIndexes": [
    {
      "Projection": {
        "NonKeyAttributes": [ "myattribute" ]
        ...
      }
      ...
    },
    {
      "ProjectionType": "INCLUDE"
      ...
    },
  ]
  ...
}

The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.

Parameters

  • pathpathpathpathPath — - The path of the property, you can use dot notation to override values in complex types.
  • valuevaluevaluevalueValue — - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#
Adds an override that deletes the value of a property from the resource definition.
1 parameter

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#
Adds an override to a resource property.

Syntactic sugar for addOverride("Properties.<...>", value).

2 parameters

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path of the property.
  • valuevaluevaluevalueValue — The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#
Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.

applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#
Sets the cross-stack reference strength for this resource.

When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.

1 parameter

Parameters

  • strengthstrengthstrengthstrengthStrength — - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#
Sets the deletion policy of the resource based on the removal policy specified.
notes

The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.

The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:

arnForRcsAgent(resource: IRcsAgentRef): string@staticmethod def arn_for_rcs_agent(resource: IRcsAgentRef) -> strpublic static String arnForRcsAgent(IRcsAgentRef resource)public static string ArnForRcsAgent(IRcsAgentRef resource)func ArnForRcsAgent(Resource IRcsAgentRef) *stringstatic#
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#
getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#
Returns a token for an runtime attribute of this resource.

Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.

1 parameter

Parameters

  • attributeNameattribute_nameattributeNameattributeNameAttributeName — The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#
Retrieve a value value from the CloudFormation Resource Metadata.
inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#
Examines the CloudFormation resource and discloses attributes.
1 parameter

Parameters

  • inspectorinspectorinspectorinspectorInspector — tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#
Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.

returns

Returns: The construct as a stack element or undefined if it is not a stack element.

isCfnRcsAgent(x: any): boolean@staticmethod def is_cfn_rcs_agent(x: Any) -> boolpublic static Boolean isCfnRcsAgent(Object x)public static bool IsCfnRcsAgent(object x)func IsCfnRcsAgent(X interface{}) *boolstatic#
Checks whether the given object is a CfnRcsAgent.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#
Check whether the given object is a CfnResource.
isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#
Checks if `x` is a construct.
notes · 1 parameter · returns

Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.

Parameters

  • xxxxX — Any object.

Returns: true if x is an object created from a class which extends Construct.

obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#
Retrieves an array of resources and stacks this resource depends on.

For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.

overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#
Overrides the auto-generated logical ID with a specific ID.
1 parameter

Parameters

  • newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId — The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#
Use `removeResourceDependency` instead

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#
Indicates that this resource no longer depends on another resource.

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#
Replaces one dependency with another.
2 parameters

Parameters

  • targettargettargettargetTarget — The dependency to replace.
  • newTargetnew_targetnewTargetnewTargetNewTarget — The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#
Returns a string representation of this construct.
returns

Returns: a string representation of this resource

with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#
Applies one or more mixins to this construct.

Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.